#!/usr/bin/perl
# swat.cgi
# Pass everything to samba's SWAT tool

require './samba-lib.pl';
require 'jcode.pl';
require './scramble.pl';

&ReadParse();

# check acls
%access = &get_module_acl();
&error_setup("<blink><font color=red>$text{'eacl_aviol'}</font></blink>");
&error("$text{'eacl_np'} $text{'eacl_pcswat'}") unless $access{'swat'};

# Check is hosts allow is in force
&get_share("global");
if (&getval('allow hosts')) {
	&ui_print_header(undef, $text{'error'}, "");
	print &text('swat_msg3', $text{'sec_onlyallow'}), "<p>\n";
	&foreign_require("inetd", "inetd-lib.pl");
	local @inets = &foreign_call("inetd", "list_inets");
	foreach $i (@inets) {
		if ($i->[3] eq 'swat' && $i->[1]) {
			# swat is configured in inetd!
			local $p = getservbyname('swat', 'tcp');
			$url = "http://$ENV{'SERVER_NAME'}:$p/";
			print &text('swat_msg4', "<a href='$url'>$url</a>"), "<p>\n";
			}
		}
	$s_index = $text{'index_sharelist'};
	&jcode::convert(\$s_index, "sjis");
	&ui_print_footer("", $s_index);
	exit;
	}

# Check if we have the password
&read_file("$module_config_directory/swat", \%swat) || &ask_password();

# Execute SWAT process
pipe(OUTr, OUTw);
pipe(INr, INw);
local $pid = fork();
if (!$pid) {
	untie(*STDIN);
	untie(*STDOUT);
	untie(*STDERR);
	open(STDIN, "<&INr");
	open(STDOUT, ">&OUTw");
	open(STDERR, ">&OUTw");
	close(OUTr); close(INw);
	undef %ENV;
	exec($config{'swat_path'});
	print "Exec failed : $!\n";
	exit 1;
	}
close(OUTw); close(INr);

if ($current_lang =~ /ja/){
    $swat_lang = ja;
} else {
    $swat_lang = $current_lang;
}

# Feed HTTP request and read output
$swat{'pass'} = &descramble($swat{'pass'});
$auth = &encode_base64("$swat{'user'}:$swat{'pass'}");
$auth =~ s/\n//g;
select(INw); $| = 1; select(STDOUT);
$path = $ENV{'PATH_INFO'} || "/";
if ($ENV{'REQUEST_METHOD'} eq 'GET') {
	print INw "GET $path?$in HTTP/1.1\n";
	print INw "Accept-Language: $swat_lang\r\n";
	print INw "Authorization: basic $auth\n";
	print INw "\n";
	}
else {
	print INw "POST $path HTTP/1.1\r\n";
	print INw "Accept-Language: $swat_lang\r\n";
	print INw "Authorization: basic $auth\r\n";
	print INw "Content-length: ",length($in),"\r\n";
	print INw "Content-type: application/x-www-form-urlencoded\r\n";
	print INw "\r\n",$in;
	}
close(INw);
$reply = <OUTr>;
if ($reply =~ /\s401\s/) {
	&ask_password();
	}
if ($ENV{'PATH_INFO'} =~ /\.(gif|jpg|jpeg|png)$/i) {
	# An image .. just output it
	while(<OUTr>) { print; }
	}
else {
	# An HTML page .. fix up links
	$url = "$gconfig{'webprefix'}/$module_name/swat.cgi";
	while(<OUTr>) {
		s/src="(\/[^"]*)"/src="$url$1"/gi;
		s/href="(\/[^"]*)"/href="$url$1"/gi;
		s/action="(\/[^"]*)"/action="$url$1"/gi;
		s/"(\/status?[^"]*)"/"$url$1"/gi;
		print $_ if (!/<\/body>/i && !/<\/html>/i);
		}
	print "<table width=100% cellpadding=0 cellspacing=0><tr><td>\n";
	$s_index = $text{'index_sharelist'};
	&jcode::convert(\$s_index, "sjis");
	&ui_print_footer("/$module_name/", $s_index, 1);
	print "</td> <td align=right><a href='/$module_name/logout.cgi'>",
	      "$text{'swat_logout'}</a></td> </tr></table></body></html>\n";
	}

sub ask_password
{
&ui_print_header(undef, $text{'swat_title'}, "");
if (%swat) {
	print $text{'swat_msg1'}, " <br>\n";
	}
else {
	print $text{'swat_msg2'}, " <br>\n";
	}
print "<form action=swat_save.cgi>\n";
print "<center><table border>\n";
print "<tr $tb> <td><b>$text{'swat_list'}</b></td> </tr>\n";
print "<tr $cb> <td><table cellpadding=2>\n";
print "<tr> <td><b>$text{'swat_username'}</b></td>\n";
print "<td><input name=user size=20 value='$swat{'user'}'></td> </tr>\n";
print "<tr> <td><b>$text{'swat_password'}</b></td>\n";
print "<td><input name=pass size=20 type=password></td> </tr>\n";
print "</table></td></tr></table>\n";
print "<input type=submit value=\"", $text{'swat_login'},
      "\"> <input type=reset value=\"", $text{'swat_clear'}, "\">\n";
print "</center></form>\n";
&ui_print_footer("", $text{'index_sharelist'});
exit;
}

# output shiftjis text(message, [substitute]+)
sub text_s
  {

    local $rv = $text{$_[0]};
    local $i;
    local $s_rv = $rv;
    jcode::convert(\$s_rv, "sjis");
    for($i=1; $i<@_; $i++) {
	$s_rv =~ s/\$$i/$_[$i]/g;
    }
    return $s_rv;
}

sub footer_s
  {
    if (@_) {
	local $url = $_[0];
	if ($url ne '/' || !$tconfig{'noindex'}) {
	    if ($url eq '/') {
		$url = "/?cat=$module_info{'category'}";
	    }
	    elsif ($url eq '' && $module_name) {
		$url = "/$module_name/";
	    }
	    elsif ($url =~ /^\?/ && $module_name) {
		$url = "/$module_name/$url";
	    }
	    print "<a href=\"$url\"><img alt=\"<-\" align=middle border=0 src=/images/left.gif></a>\n";
	    print "&nbsp;&nbsp;<a href=\"$url\">",&text_s('main_return', $_[1]),"</a><p>\n";
	}
    }
    local $postbody = $tconfig{'postbody'};
    if ($postbody) {
	local $hostname = &get_system_hostname();
	local $version = &get_webmin_version();
	local $os_type = $gconfig{'real_os_type'} ?
	    $gconfig{'real_os_type'} : $gconfig{'os_type'};
	local $os_version = $gconfig{'real_os_version'} ?
	    $gconfig{'real_os_version'} : $gconfig{'os_version'};
	$postbody =~ s/%HOSTNAME%/$hostname/g;
	$postbody =~ s/%VERSION%/$version/g;
	$postbody =~ s/%USER%/$ENV{'REMOTE_USER'}/g;
	$postbody =~ s/%OS%/$os_type $os_version/g;
	print "$postbody\n";
    }
    print "</body></html>\n" if (!$_[2]);
}
